import { Buffer } from './Buffer';
import { Window } from './Window';
import { Tabpage } from './Tabpage';
export declare enum ExtType {
    Buffer = 0,
    Window = 1,
    Tabpage = 2
}
export interface ExtTypeConstructor<T> {
    new (...args: any[]): T;
}
export interface MetadataType {
    constructor: ExtTypeConstructor<Buffer | Tabpage | Window>;
    name: string;
    prefix: string;
}
export declare const Metadata: MetadataType[];
export type Promisify<T> = {
    [K in keyof T]: Promise<T[K]>;
};
